#
# This file was generated using xslt from its XML file
#
# Copyright 2009, Associated Universities Inc., Washington DC
#
import sys
import os
from  casac import *
import string
from taskinit import casalog
from taskinit import xmlpath
#from taskmanager import tm
import task_delmod
def delmod(vis='', otf=True, field='', scr=False):

        """Deletes model representations in the MS

      This utility task is to be used to delete the model visibility
      data representations in the MS.  The 'otf' representation is
      the new (as of v3.4) 'scratch-less' model data, stored as
      keywords in the MS header containing model data formation
      instructions.  It is generated by the setjy, ft, and clean
      tasks (usescratch=F), and if present, overrides the 
      old-fashioned MODEL_DATA column (if present).  If a user
      wishes to use the MODEL_DATA column _after_ having operated
      with the 'otf' representation, this task can be used
      to delete the 'otf' represenatation to make the MODEL_DATA
      column visible.  (Create the MODEL_DATA column by using
      usescratch=T in setjy, ft, or clean; or by running the
      clearcal task with addmodel=T.)

      If otf=T, specific fields can be selected for deletion
      using standard field selection semantics.  If field='',
      all fields' models will be deleted.

      For convenience, this method also provides a means for
      deleting the MODEL_DATA column by setting scr=T.  Note
      that it is not possible to delete the MODEL_DATA column
      per field.

      If otf=F and scr=F, delmod will provide a listing
      of the header field records.


 
        """

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['vis'] = vis
        mytmp['otf'] = otf
        mytmp['field'] = field
        mytmp['scr'] = scr
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
	trec = casac.utils().torecord(pathname+'delmod.xml')

        casalog.origin('delmod')
        if trec.has_key('delmod') and casac.utils().verify(mytmp, trec['delmod']) :
	    result = task_delmod.delmod(vis, otf, field, scr)

	else :
	  result = False
        return result
