#
# This file was generated using xslt from its XML file
#
# Copyright 2008, Associated Universities Inc., Washington DC
#
import sys
import os
from casac import *
import string
import time
from casa_stack_manip import stack_frame_find
import gc
import numpy
from odict import odict
from task_importfits import importfits
from taskinit import casalog
from taskinit import xmlpath
class importfits_pg_:
    __name__ = "importfits"

    def __init__(self) :
       self.__bases__ = (importfits_pg_,)
       self.__doc__ = self.__call__.__doc__


    def __call__(self, fitsimage=None,imagename=None,whichrep=None,whichhdu=None,zeroblanks=None,overwrite=None,defaultaxes=None,defaultaxesvalues=None,beam=None,):

        myf=stack_frame_find( )
        myf['__last_task'] = 'importfits'
        myf['taskname'] = 'importfits'
        ###
        myf['update_params'](func=myf['taskname'],printtext=False)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
	function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames,self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True
                        #myf[key]=keyVal

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
                      if len(keyVal) > 0 :
		         exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')
		      else :
		         exec('myparams[key] = ' + key + ' = {}')

	else :
            uselessvariable = None 
            myparams['fitsimage'] = fitsimage = myf['fitsimage']
            myparams['imagename'] = imagename = myf['imagename']
            myparams['whichrep'] = whichrep = myf['whichrep']
            myparams['whichhdu'] = whichhdu = myf['whichhdu']
            myparams['zeroblanks'] = zeroblanks = myf['zeroblanks']
            myparams['overwrite'] = overwrite = myf['overwrite']
            myparams['defaultaxes'] = defaultaxes = myf['defaultaxes']
            myparams['defaultaxesvalues'] = defaultaxesvalues = myf['defaultaxesvalues']
            myparams['beam'] = beam = myf['beam']


	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['fitsimage'] = fitsimage
        mytmp['imagename'] = imagename
        mytmp['whichrep'] = whichrep
        mytmp['whichhdu'] = whichhdu
        mytmp['zeroblanks'] = zeroblanks
        mytmp['overwrite'] = overwrite
        mytmp['defaultaxes'] = defaultaxes
        mytmp['defaultaxesvalues'] = defaultaxesvalues
        mytmp['beam'] = beam
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
	trec = casac.utils().torecord(pathname+'importfits.xml')

        casalog.origin('importfits')
        if not trec.has_key('importfits') or not casac.utils().verify(mytmp, trec['importfits']) :
	    return False


	try :
          casalog.post('')
          casalog.post('##########################################')
          casalog.post('##### Begin Task: importfits           #####')
          casalog.post('')
          result = importfits(fitsimage, imagename, whichrep, whichhdu, zeroblanks, overwrite, defaultaxes, defaultaxesvalues, beam)
          casalog.post('')
          casalog.post('##### End Task: importfits           #####')
          casalog.post('##########################################')


# saveinputs for individule engine has no use
# saveinputs should alos be removed from casa_in_py.py
#
#
#          saveinputs = myf['saveinputs']
#          saveinputs('importfits', 'importfits.last', myparams)
#
#
	except Exception, instance:
	  if(myf.has_key('__rethrow_casa_exceptions') and myf['__rethrow_casa_exceptions']) :
	     raise
	  else:
	     tname = 'importfits'
	     casalog.post('An error occurred running task %s: %s' % (tname,instance), 'ERROR')
	     pass
	casalog.origin('')

        gc.collect()
        return result
#
#
##
#    def paramgui(self, useGlobals=True):
#        """
#        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
#        """
#        import paramgui
#
#        myf = stack_frame_find( )
#
#        if useGlobals:
#            paramgui.setGlobals(myf)
#        else:
#            paramgui.setGlobals({})
#
#        paramgui.runTask('importfits', myf['_ip'])
#        paramgui.setGlobals({})
#
#
#
#
    def defaults(self, param=None):
        myf=stack_frame_find( )
        a = odict()
        a['fitsimage']  = ''
        a['imagename']  = ''
        a['whichrep']  = 0
        a['whichhdu']  = -1
        a['zeroblanks']  = True
        a['overwrite']  = False
        a['defaultaxes']  = False
        a['defaultaxesvalues']  = []
        a['beam']  = []


### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
	        if(a.has_key(param)):
		   #if(type(a[param]) == dict) :
		   #   return a[param][len(a[param])-1]['value']
	   	   #else :
		      return a[param]


#
#
    def check_params(self, param=None, value=None):
      myf=stack_frame_find( )

#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value

#
#
    def itsdefault(self, paramname) :
        a = {}
        a['fitsimage']  = ''
        a['imagename']  = ''
        a['whichrep']  = 0
        a['whichhdu']  = -1
        a['zeroblanks']  = True
        a['overwrite']  = False
        a['defaultaxes']  = False
        a['defaultaxesvalues']  = []
        a['beam']  = []

        if a.has_key(paramname) :
	      return a[paramname]
importfits_pg = importfits_pg_()
