#
# This file was generated using xslt from its XML file
#
# Copyright 2008, Associated Universities Inc., Washington DC
#
import sys
import os
from casac import *
import string
import time
from casa_stack_manip import stack_frame_find
import gc
import numpy
from odict import odict
from task_rmfit import rmfit
from taskinit import casalog
from taskinit import xmlpath
class rmfit_pg_:
    __name__ = "rmfit"

    def __init__(self) :
       self.__bases__ = (rmfit_pg_,)
       self.__doc__ = self.__call__.__doc__


    def __call__(self, imagename=None,rm=None,rmerr=None,pa0=None,pa0err=None,nturns=None,chisq=None,sigma=None,rmfg=None,rmmax=None,maxpaerr=None,):

        myf=stack_frame_find( )
        myf['__last_task'] = 'rmfit'
        myf['taskname'] = 'rmfit'
        ###
        myf['update_params'](func=myf['taskname'],printtext=False)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
	function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames,self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True
                        #myf[key]=keyVal

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
                      if len(keyVal) > 0 :
		         exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')
		      else :
		         exec('myparams[key] = ' + key + ' = {}')

	else :
            uselessvariable = None 
            myparams['imagename'] = imagename = myf['imagename']
            myparams['rm'] = rm = myf['rm']
            myparams['rmerr'] = rmerr = myf['rmerr']
            myparams['pa0'] = pa0 = myf['pa0']
            myparams['pa0err'] = pa0err = myf['pa0err']
            myparams['nturns'] = nturns = myf['nturns']
            myparams['chisq'] = chisq = myf['chisq']
            myparams['sigma'] = sigma = myf['sigma']
            myparams['rmfg'] = rmfg = myf['rmfg']
            myparams['rmmax'] = rmmax = myf['rmmax']
            myparams['maxpaerr'] = maxpaerr = myf['maxpaerr']


	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['imagename'] = imagename
        mytmp['rm'] = rm
        mytmp['rmerr'] = rmerr
        mytmp['pa0'] = pa0
        mytmp['pa0err'] = pa0err
        mytmp['nturns'] = nturns
        mytmp['chisq'] = chisq
        mytmp['sigma'] = sigma
        mytmp['rmfg'] = rmfg
        mytmp['rmmax'] = rmmax
        mytmp['maxpaerr'] = maxpaerr
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
	trec = casac.utils().torecord(pathname+'rmfit.xml')

        casalog.origin('rmfit')
        if not trec.has_key('rmfit') or not casac.utils().verify(mytmp, trec['rmfit']) :
	    return False


	try :
          casalog.post('')
          casalog.post('##########################################')
          casalog.post('##### Begin Task: rmfit           #####')
          casalog.post('')
          result = rmfit(imagename, rm, rmerr, pa0, pa0err, nturns, chisq, sigma, rmfg, rmmax, maxpaerr)
          casalog.post('')
          casalog.post('##### End Task: rmfit           #####')
          casalog.post('##########################################')


# saveinputs for individule engine has no use
# saveinputs should alos be removed from casa_in_py.py
#
#
#          saveinputs = myf['saveinputs']
#          saveinputs('rmfit', 'rmfit.last', myparams)
#
#
	except Exception, instance:
	  if(myf.has_key('__rethrow_casa_exceptions') and myf['__rethrow_casa_exceptions']) :
	     raise
	  else:
	     tname = 'rmfit'
	     casalog.post('An error occurred running task %s: %s' % (tname,instance), 'ERROR')
	     pass
	casalog.origin('')

        gc.collect()
        return result
#
#
##
#    def paramgui(self, useGlobals=True):
#        """
#        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
#        """
#        import paramgui
#
#        myf = stack_frame_find( )
#
#        if useGlobals:
#            paramgui.setGlobals(myf)
#        else:
#            paramgui.setGlobals({})
#
#        paramgui.runTask('rmfit', myf['_ip'])
#        paramgui.setGlobals({})
#
#
#
#
    def defaults(self, param=None):
        myf=stack_frame_find( )
        a = odict()
        a['imagename']  = '', 
        a['rm']  = ''
        a['rmerr']  = ''
        a['pa0']  = ''
        a['pa0err']  = ''
        a['nturns']  = ''
        a['chisq']  = ''
        a['sigma']  = -1
        a['rmfg']  = 0.0
        a['rmmax']  = 0.0
        a['maxpaerr']  = 1e30


### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
	        if(a.has_key(param)):
		   #if(type(a[param]) == dict) :
		   #   return a[param][len(a[param])-1]['value']
	   	   #else :
		      return a[param]


#
#
    def check_params(self, param=None, value=None):
      myf=stack_frame_find( )

#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value

#
#
    def itsdefault(self, paramname) :
        a = {}
        a['imagename']  = '', 
        a['rm']  = ''
        a['rmerr']  = ''
        a['pa0']  = ''
        a['pa0err']  = ''
        a['nturns']  = ''
        a['chisq']  = ''
        a['sigma']  = -1
        a['rmfg']  = 0.0
        a['rmmax']  = 0.0
        a['maxpaerr']  = 1e30

        if a.has_key(paramname) :
	      return a[paramname]
rmfit_pg = rmfit_pg_()
